import PyIPSDK
import PyIPSDK.IPSDKIPLAdvancedMorphology as advmorpho
import PyIPSDK.IPSDKIPLArithmetic as arithm
import PyIPSDK.IPSDKIPLUtility as util
import PyIPSDK.IPSDKIPLBasicMorphology as morpho
import PyIPSDK.IPSDKIPLLogical as logic

def My_function( inImg1, inMask):   

	# verifier si les 2 images sont toutes les deux 2D ou 3D
	if inImg1.getVolumeGeometryType() == PyIPSDK.eVGT_2d:
		if not inMask: 
			img1 = advmorpho.removeBorder2dImg(inImg1)
		
			img2 = arithm.addImgImg(inImg1, img1)
		
			output = util.convertImg(img2, PyIPSDK.eImageBufferType.eIBT_Label8)
		else:
			imgNot = logic.logicalNotImg(inMask)
		
			structuringElement= PyIPSDK.circularSEXYInfo(1)
			imgNot = morpho.dilate2dImg(imgNot, structuringElement)
		
			imgOutside = advmorpho.binaryReconstruction2dImg(inImg1, imgNot)
			imgNot.clear()
	
			img6 = logic.bitwiseSubImgImg(inImg1,imgOutside)
			imgOutside.clear()
	
			img7 = arithm.addImgImg(inImg1, img6)
			img6.clear()
	
			img8 = logic.maskImg(img7,inMask)
			img7.clear()
	
			output = util.convertImg(img8, PyIPSDK.eImageBufferType.eIBT_Label8)
	else:
		if not inMask: 
			img1 = advmorpho.removeBorder3dImg(inImg1)
		
			img2 = arithm.addImgImg(inImg1, img1)
		
			output = util.convertImg(img2, PyIPSDK.eImageBufferType.eIBT_Label8)
		else:
			imgNot = logic.logicalNotImg(inMask)
		
			structuringElement= PyIPSDK.sphericalSEXYZInfo(1)
			imgNot = morpho.dilate3dImg(imgNot, structuringElement)
		
			imgOutside = advmorpho.binaryReconstruction3dImg(inImg1, imgNot)
			imgNot.clear()
	
			img6 = logic.bitwiseSubImgImg(inImg1,imgOutside)
			imgOutside.clear()
	
			img7 = arithm.addImgImg(inImg1, img6)
			img6.clear()
	
			img8 = logic.maskImg(img7,inMask)
			img7.clear()
	
			output = util.convertImg(img8, PyIPSDK.eImageBufferType.eIBT_Label8)
	return output
